<?php
// -*- coding: utf-8 -*-
/*************************************************************************
 *
 * fckairbnb.tamagothi.de 
 * $Id: index.php,v 1.12 2020/08/19 13:56:08 elias Exp $
 *
 * Ich weiß genau, dass ich für dieses schnell zusammengestrokelte
 * Dingens keinen Schönheitspreis bekomme, aber es sollte trotzdem
 * leicht anzupassen sein. In den meisten Fällen dürfte es ausreichen,
 * die Konstanten am Anfang der Datei anzupassen. 
 * 
 * Dies ist Freie Software, lizenziert unter den Bedingungen der
 * Piratenlizenz. Nehmt es hin und macht etwas draus!
 *
 * http://www.tamagothi.de/impressum/lizenz/
 *
 * Fck teh fcking fckerz!
 *
 ************************************************************************/

// Konfiguration
// -------------
//
// In den meisten Fällen ist dies der einzige Teil, der angepasst
// werden muss, wenn man diese Website für einen anderen Ort
// verwenden möchte. Ich hoffe mal, dass die Namen der Konstanten
// völlig selbsterklärend sind und erspare mir und euch lange
// Kommentare. 

define ("ORT_MELDUNG",       "in Hannover");
define ("URL_WEBSITE",       "http://fckairbnb.tamagothi.de/");
define ("LINK_IMPRESSUM",    "http://www.tamagothi.de/impressum/");
define ("NAME_IMPRESSUM",    "Elias Schwerdtfeger");
define ("MAIL_EMPFAENGER",   "fckairbnb@tamagothi.de");
define ("NAME_ABSENDER",     "Elias Schwerdtfeger");
define ("MAIL_ABSENDER",     "fckairbnb@tamagothi.de");
define ("MAIL_SUBJECT",      "Meldung eines Mietwohungsmissbrauches");

// Bitte eine eigene, willkürliche Zeichenkette verwenden!
// Damit werden die blockierten IP-Adressen "unlesbar" gemacht.

define ("HASH_SALT",         "rePr39klawiX3!2pr");

// Das Folgende muss im Regelfall nicht geändert werden

define ("IP_BLOCKADE",       60 * 60 * 24 * 2); // Zwei Tage in Sekunden
define ("IP_BLOCKFILE",      ".ipblock");
define ("COUNTER_FILE",      ".counter");
define ("DOWNLOAD_LINK",     "http://www.tamagothi.de/software/fckairbnb/");

// Zahlwörter für die CAPTCHAs

$zahlen = array (
    "Null",
    "Eins", "Zwei", "Drei", "Vier", "Fünf",
    "Sechs", "Sieben", "Acht", "Neun", "Zehn",
    "Elf", "Zwölf", "Dreizehn", "Vierzehn", "Fünfzehn",
    "Sechzehn", "Siebzehn", "Achtzehn", "Neunzehn", "Zwanzig"
);


// Unterprogramme
// --------------

function hash_ip ($ipaddr)
{
    return md5 (sha1 ($ipaddr . HASH_SALT . $ipaddr));
}

function get_db_filename ()
{
    return dirname ($_SERVER ['SCRIPT_FILENAME']) . "/" . IP_BLOCKFILE;
}

function get_counter_filename ()
{
    return dirname ($_SERVER ['SCRIPT_FILENAME']) . "/" . COUNTER_FILE;
}

function flock_wait ($fh, $mode)
{
    while (!flock ($fh, $mode))
        usleep (125000); // Eine achtel Sekunde warten, neu versuchen
}

function check_ip ($ipaddr)
{
    $checkfor = hash_ip ($ipaddr);
    $allowed = true;
    $writeback = array ();
    $writeflag = false;
    $delete_before = time () - IP_BLOCKADE;
    
    $f = @fopen (get_db_filename (), "r");
    if (!$f) {
        echo "<strong>Fehler beim Öffnen zum Lesen</strong>\n";
        return false;
    }
    flock_wait ($f, LOCK_SH);
    while ($line = fgets ($f)) {
        $line = chop ($line);
        if (strlen ($line) == 0) break;
        $fields = explode (":::", $line);
        if ($fields [1] >= $delete_before) {
            if (strcmp ($fields [0], $checkfor) == 0)
                $allowed = false;
            $writeback[] = $line;
        } else
            $writeflag = true; // Nach Löschung einer Zeile zurückschreiben
    }
    flock_wait ($f, LOCK_UN);
    fclose ($f);
    if ($writeflag) {
        $f = @fopen (get_db_filename (), "w");
        if (!$f) {
            echo "<strong>Fehler beim Öffnen zum Schreiben</strong>";
            return false;
        }
        flock_wait ($f, LOCK_EX);
        foreach ($writeback as $line)
            fwrite ($f, $line . "\n");
        flock_wait ($f, LOCK_UN);
        fclose ($f);
    }
    return $allowed;
}

function increment_counter ()
{
    $f = @fopen (get_counter_filename (), "r");
    if (!$f)
        return false;
    flock_wait ($f, LOCK_SH);
    $cnt = (int) fgets ($f);
    flock_wait ($f, LOCK_UN);
    fclose ($f);
    $cnt++;
    $f = @fopen (get_counter_filename (), "w");
    if (!$f)
        return false;
    flock_wait ($f, LOCK_EX);
    fwrite ($f, $cnt . "\n");
    flock_wait ($f, LOCK_UN);
    fclose ($f);
    return true;
}

function block_ip ($ipaddr)
{
    $now = time ();
    $line = hash_ip ($ipaddr) . ":::" . $now;
    
    $f = fopen (get_db_filename (), "a");
    if (!$f) {
        echo "<strong>Interner Fehler beim Sperren der IP-Adresse</strong>\n";
        return false;
    }
    flock_wait ($f, LOCK_EX);
    fwrite ($f, $line . "\n");
    flock_wait ($f, LOCK_UN);
    fclose ($f);
    return true;
}

function captcha_hash ($number, $salt)
{
    $number = trim ($number);
    $hn = 3 * $number * $number - $number + 1337; // Security by obscurity
    return md5 (sha1 ($hn . $salt . HASH_SALT . $_SERVER ['REMOTE_ADDR']));
}

function numberword ($n)
{
    global $zahlen;
    if ($n > 20 || mt_rand (1, 3) == 1)
        return "$n";
    else
        return $zahlen [$n];
}

function create_captcha_challenge ()
{
    $q = array ("Was ergibt");

    $n1 = mt_rand (1, 12);
    $n2 = mt_rand (2, 20);
    if ($n2 < $n1) {
        $tmp = $n1;
        $n1 = $n2;
        $n2 = $tmp;
    }
    $mode = mt_rand (1, 4);
    switch ($mode) {
    case 1:
        $result = $n1 + $n2;
        $q [] = numberword ($n1);
        $q [] = mt_rand (1, 3) < 3 ? "plus" : "addiert mit";
        $q [] = numberword ($n2);
        break;
    case 2:
        $result = $n2 - $n1;
        $q [] = numberword ($n2);
        $q [] = mt_rand (1, 3) < 3 ? "minus" : "subtrahiert um";
        $q [] = numberword ($n1);
        break;
    case 3:
        $result = $n1 * $n2;
        $q [] = numberword ($n2);
        $q [] = mt_rand (1, 3) < 3 ? "mal" : "multipliziert mit";
        $q [] = numberword ($n1);
        break;
    case 4:
        $n3 = $n1 * $n2;
        $result = $n1;
        $q [] = numberword ($n3);
        $q [] = mt_rand (1, 3) < 3 ? "geteilt durch" : "dividiert durch";
        $q [] = numberword ($n2);
        break;
    }
    $salt = mt_rand (100000, 999999);
    $hash = captcha_hash ($result, $salt);
    return array (
        "challenge" => implode (" ", $q) . "?",
        "hash" => $hash,
        "salt" => $salt,
        "result" => $result
    );
}

function process ()
{
    $rv = true;
    $error = array ();

    $strasse = trim ($_POST ['strasse']);
    $hausnummer = trim ($_POST ['hausnummer']);
    $ortsteil = trim ($_POST ['ortsteil']);
    $detail = trim ($_POST ['detail']);
    $more = trim ($_POST ['more']);
    $chash = trim ($_POST ['chash']);
    $csalt = trim ($_POST ['csalt']);
    $captcha = trim ((int) $_POST ['captcha']);
    
    if (strlen ($strasse) == 0)
        $error [] = "Bitte geben sie die Straße an";
    if (strlen ($strasse) > 80)
        $error [] = "Der Straßenname ist zu lang, bitte kürzen";
    if (strlen ($hausnummer) == 0)
        $error [] = "Bitte geben sie die Hausnummer an";
    if (strlen ($hausnummer) > 12)
        $error [] = "Die Hausnummer ist zu lang, bitte kürzen";
    if (strlen ($ortsteil) > 80)
        $error [] = "Der Ortsteil ist zu lang, bitte kürzen";
    if (strlen ($detail) == 0)
        $error [] = "Bitte machen sie die genaueren Angaben";
    if (strlen ($detail) > 80)
        $error [] = "Die genaueren Angaben sind zu lang, bitte kürzen";
    if (strlen ($more) > 1000)
        $error [] = "Die weiteren Angaben zur Meldung sind zu lang, bitte kürzen";
    if (strlen ($captcha) == 0)
        $error [] = "Bitte beantworten sie die Spamschutz-Frage";
    if (strcmp ($chash, captcha_hash ($captcha, $csalt)) != 0)
        $error [] = "Sie haben die Spamschutz-Frage falsch beantwortet";

    if (count ($error) == 0) {
        $amsg = array ();
        $amsg [] = "Sehr geehrte Damen und Herren,";
        $amsg [] = "";
        $amsg [] = wordwrap ("die folgende Meldung eines mutmaßlichen Missbrauchs einer Mietwohnung als »wildes« Hotelzimmer wurde anonymisiert über die Website", 70, "\r\n");
        $amsg [] = "";
        $amsg [] = "    " . URL_WEBSITE;
        $amsg [] = "";
        $amsg [] = wordwrap ("abgegeben. Ich habe keine Informationen darüber, wer diese Meldung gemacht hat und bitte sie freundlich darum, der Sache auf den Grund zu gehen.", 70, "\r\n");
        $amsg [] = "";
        
        $amsg [] = "Die folgenden Angaben wurden dabei gemacht:";
        $amsg [] = "";

        $amsg [] = "_Meldung beginnt_";
        $amsg [] = "";
    
        $amsg [] = "Straße:";
        $amsg [] = $strasse;
        $amsg [] = "";

        $amsg [] = "Hausnummer:";
        $amsg [] = $hausnummer;
        $amsg [] = "";

        if (strlen ($ortsteil) > 0) {
            $amsg [] = "Ortsteil:";
            $amsg [] = $ortsteil;
            $amsg [] = "";
        }

        $amsg [] = "Genauere Angabe:";
        $amsg [] = $detail;
        $amsg [] = "";

        if (strlen ($more) > 0) {
            $amsg [] = "Weitere Angaben:";
            $amsg [] = wordwrap ($more, 70, "\r\n");
            $amsg [] = "";
        }

        $amsg [] = "_Meldung endet_";
        $amsg [] = "";

        $amsg [] = "Mit freundlichen Grüßen";
        $amsg [] = "";
        $amsg [] = "";
        $amsg [] = NAME_ABSENDER;
        $amsg [] = "";
        
        $msg = implode ("\r\n", $amsg);

        $ahead = array (
            "From: " . NAME_ABSENDER . " <" . MAIL_ABSENDER . ">",
            "Content-Type: text/plain; charset=utf-8"
        );

        $head = implode ("\r\n", $ahead);
        
        if (!mail (MAIL_EMPFAENGER, MAIL_SUBJECT, $msg, $head))
            $error [] = "Der Versand der E-Mail ist gescheitert";
    }

    if (count ($error) > 0) {
?>
        <strong>Es sind Fehler aufgetreten.</strong>
        <ul>
<?php
        foreach ($error as $line)
            echo "<li>$line</li>\n";
?>
        </ul>
        <p>Sie können ihre Eingabe bearbeiten und es noch einmal versuchen.</p>
<?php
        $rv = false;
    } else {
        block_ip ($_SERVER ['REMOTE_ADDR']);
        increment_counter ();
    }
    return $rv;
}

// Darstellung des Formulars
// -------------------------
// Nein, das ist kein schöner Code, ich weiß... ;)

function show_form ()
{
    $capt = create_captcha_challenge ();
    
?>
    <form method="post" action="<?php echo $_SERVER ['PHP_SELF'] ?>#anonym">
    <p>
    <label for="strasse">Straße:</label>
    <input name="strasse" id="strasse" type="text" size="40" maxlength="80" value="<?php if (isset ($_POST ['strasse'])) { echo $_POST ['strasse']; } ?>" required />
    </p>
    <p>
    <label for="hausnummer">Hausnummer:</label>
    <input name="hausnummer" id="hausnummer" type="text" size="5" maxlength="12" value="<?php if (isset ($_POST ['hausnummer'])) { echo $_POST ['hausnummer']; } ?>" required />
    </p>
    <p>
    <label for="ortsteil">Ortsteil (wenn nötig):</label>
    <input name="ortsteil" id="ortsteil" type="text" size="40" maxlength="80" value="<?php if (isset ($_POST ['ortsteil'])) { echo $_POST ['ortsteil']; } ?>" >
    </p>
    <p>
    <label for="detail">Genauere Angabe (zum Beispiel 2. OG links, Hinterhaus):</label>
    <input name="detail" id="detail" type="text" size="40" maxlength="80" value="<?php if (isset ($_POST ['detail'])) { echo $_POST['detail']; } ?>" required />
    </p>
    <p>
    <label for="more">Weitere Angaben zur Meldung (bei Bedarf):</label>
    <textarea name="more" id="more" cols="40" rows="12"><?php if (isset ($_POST ['more'])) { echo $_POST['more']; } ?></textarea>
    </p>
    <p>
    <label for="captcha">Spamschutz (Antwort bitte in Ziffern eingeben):</label>
    <input type="hidden" name="chash" value="<?php echo $capt ["hash"]; ?>" />
    <input type="hidden" name="csalt" value="<?php echo $capt ["salt"]; ?>" />
    <input type="text" size="40" value="<?php echo $capt ["challenge"]; ?>" readonly /><br />
    <input name="captcha" id="captcha" type="text" size="5" maxlength="3" required />
    </p>
    <p>
    <input type="hidden" name="process" value="1" />
    <input type="submit" value="Meldung absenden" />
    </p>
    </form>
<?php
    return true;
}

// Ein leicht zu machender Fehler und ein Hinweis!
// -----------------------------------------------
// Ja, ich weiß, unnötiges Sicherheitsnetz, wer es nicht braucht, lösche
// es bitte einfach. Aber ich gehe davon aus, dass auch unerfahrene
// Menschen dieses Skriptchen zum Laufen bringen möchten, und die freuen
// sich über eine menschenlesbare Fehlermeldung.

if (!is_writeable (get_db_filename ()) || !is_writeable (get_counter_filename ()))
{
    if (!@touch (get_db_filename ()) || !@touch (get_counter_filename ())) {
?>
        <html>
          <head>
            <meta charset="utf-8" />
            <title>Interner Fehler</title>
          </head>
          <body>
            <h1>Interner Fehler</h1>
            <p>Die Dateien <code><?php echo get_db_filename (); ?></code> und <code><?php echo get_counter_filename (); ?></code> müssen auf dem Server existieren und mit den Berechtigungen des Webservers schreibbar sein. Bitte einfach leere Dateien anlegen und die Rechte entsprechend setzen!</p>
            <pre>
              $ sudo touch <?php echo get_db_filename (); ?> 
              $ sudo chmod 0666 <?php echo get_db_filename (); ?> 
              $ sudo touch <?php echo get_counter_filename (); ?> 
              $ sudo chmod 0666 <?php echo get_counter_filename (); ?>
            </pre>
            <p>Natürlich können sie die Rechte auch über ihre FTP-Software setzen, und vermutlich finden sie das einfacher. Näheres erfahren sie in der Datei <code>LIESMICH.txt</code>, die sie beim Download erhalten haben sollten.</p>
            <p>Danach sollte alles funktionieren.</p>
          </body>
        </html>
<?php
        die ();
    }
}


// Dargestellte Website
// --------------------

?>
<!DOCTYPE html>
<html lang="de">
  <head>
    <meta charset="utf-8" />
    <!--[if lt IE 9]>
    <script>
      var e = ("abbr,article,aside,audio,canvas,datalist,details," +
      "figure,footer,header,hgroup,mark,menu,meter,nav,output," +
      "progress,section,time,video").split(',');
      for (var i = 0; i < e.length; i++) { document.createElement(e[i]);  }
    </script>
    <![endif]-->
    <link rel="shortcut icon" href="logo.png" />
    <link rel="stylesheet" href="style.css" />
    <title>Airbnb-Wohnraum-Missbrauch <?php echo ORT_MELDUNG; ?> anonym melden</title>
  </head>
  <body>
    <div id="all">
      <h1>Mietwohnungsmissbrauch <?php echo ORT_MELDUNG; ?> melden</h1>
      <nav>
        <a href="#intro" name="nav">Verstehen</a>
        <a href="#meldung">Melden</a>
        <a href="#anonym">Anonym</a>
        <a href="#daten">Datenschutz</a>
        <a href="#dabei">Mitmachen</a>
        <a href="#impressum">Impressum</a>
      </nav>
 
      <h2>Erklärung <a name="intro" href="#nav" title="Zurück">⇧</a></h2>
      <p>Immer häufiger werden Mietwohnungen über <a href="https://de.wikipedia.org/wiki/Airbnb">Airbnb</a> oder vergleichbare Dienstleister dauerhaft in »wilde« Hotelzimmer umgewandelt. Gleichzeitig ist Wohnraum knapp und teuer geworden. Viele Menschen, insbesondere arme Menschen, leben in unangemessenen, viel zu kleinen Wohnungen, bei ihren Eltern, als Wohnungslose bei Freunden und Bekannten oder sind obdachlos geworden, so dass sie in Zelten, unter Brücken und auf der Straße leben müssen.</p>
      <p>Der Missbrauch von Mietwohnungen als »wilde« Hotelzimmer ist finanziell lukrativ. Wenn jemand eine Wohnung mietet und sie zu einem Vielfachen der Miete an Urlauber und Gäste weitervermietet, kann er leicht ein »bedingungsloses Grundeinkommen« auf Kosten aller anderen Menschen erzielen. Dass dies angesichts tausender fehlender Wohnungen, seit Jahren wegen der Wohnungsknappheit steigender Wohnungsmieten und der aus Gier und Gewinnstreben inkaufgenommen Obdachlosigkeit anderer Menschen hochgradig <em>asozial und verachtenswert</em> ist, vermindert leider die Kaufkraft des so erwirtschafteten Geldes nicht. Und für einige Zeitgenossen ist das alles, worauf es noch ankommt.</p>
      <p>Dieser Zustand muss beendet werden!</p>
      <p>Sie können dabei mithelfen. Wenn sie von einer Mietwohnung wissen, die auf diese Weise missbraucht wird, <a href="#anonym">melden sie es an die zuständigen Behörden</a>! Das kostet sie nur wenige Minuten ihrer Lebenszeit, ist sehr einfach und ein großer Beitrag dazu, das Leben und das Miteinander der Menschen <?php echo ORT_MELDUNG; ?> zu verbessern.</p>
      <p>Bitte nutzen sie diese Möglichkeit!</p>
      
      <h2>Wohnraummissbrauch melden <a name="meldung" href="#nav" title="Zurück">⇧</a></h2>
      <p>Unterstützen sie die Behörden dabei, den Missbrauch und damit die Verknappung von Wohnraum <?php echo ORT_MELDUNG; ?> zu bekämpfen, indem sie eine Meldung erstatten!</p>
      <p>Sie können einfach direkt und eine Meldung in Form einer<br /><a href="mailto:<?php echo MAIL_EMPFAENGER; ?>">E-Mail an <?php echo MAIL_EMPFAENGER; ?></a><br />einreichen. Bitte formulieren sie diese E-Mail sachlich und höflich! Sie wird von fühlenden Menschen gelesen und bearbeitet, die Respekt verdienen, nicht von Robotern. Und bitte beschreiben sie den Sachverhalt und die betroffene Mietwohnung so genau wie möglich, um unnötige Rückfragen und Verzögerungen zu vermeiden! Niemand kann dort hellsehen.</p>
      <p>Sie können alternativ das folgende Formular verwenden, wenn sie diese Meldung anonym einreichen möchten.</p>

      <h2>Anonyme Meldung <a name="anonym" href="#nav" title="Zurück">⇧</a></h2>
      <?php $ip_okay = check_ip ($_SERVER ['REMOTE_ADDR']); ?>
      <?php if (isset ($_POST ['process']) && $ip_okay) { ?>
      <?php if (process ()) { ?>
      <p><strong>Erfolgreicher Mailversand ihrer Meldung</strong></p>
      <p>Ihre Meldung wurde anonymisiert als E-Mail an die zuständigen Behörden <?php echo ORT_MELDUNG; ?> versendet.</p>
      <p>Vielen Dank, dass sie mitgeholfen haben, den Missbrauch von Mietwohnungen zu bekämpfen.</p>
      <?php } else { /* Fehlermeldungen werden von process() ausgegeben */ ?>
      <?php show_form (); ?>
      <?php } ?>
      <?php } elseif (!$ip_okay) { ?>
      <p><strong>Sie können jetzt keine anonyme Meldung machen.</strong></p>
      <p>Die Benutzung des Formulares für eine anonyme Meldung ist zurzeit für ihre IP-Adresse gesperrt, weil mit ihrer IP-Adresse vor kurzer Zeit eine anonyme Meldung abgesendet wurde.</p>
      <p>Mit dieser Maßnahme soll verhindert werden, dass die zuständigen Behörden <?php echo ORT_MELDUNG; ?> anonym mit E-Mails geflutet werden, denn sie sollen sich ja um den Missbrauch von Mietwohnungen kümmern und diesen nach Möglichkeit abstellen, ohne dabei von Spam und dummen Akten des Vandalismus beeinträchtigt zu werden.</p>
      <p>Versuchen sie es doch einfach morgen oder übermorgen noch einmal!</p>
      <p>Bitte haben sie dafür Verständnis!</p>
      <?php } else { ?>
      <p>Bitte beachten sie, dass eine anonyme Meldung ihnen die Möglichkeit nimmt, eine Antwort der zuständigen Behörden zu erhalten. Das ist der Sinn des Wortes »anonym«.</p>
      <?php show_form (); ?>
      <?php } ?>
      
      <h2>Datenschutzerklärung <a name="daten" href="#nav" title="Zurück">⇧</a></h2>
      <p>Bei der Nutzung dieser Website kommt es nicht zur dauerhaften Speicherung von Daten. Es kommt <em>erst recht nicht</em> zu einer Weitergabe von Daten an Dritte. Datenvermeidung ist der beste und einzig wirksame Datenschutz.</p>
      <p>Nach der Benutzung des anonymen Meldeformulars wird ein kryptografischer Hash der IP-Adresse gespeichert, um die IP-Adresse vorübergehend zu sperren. Es ist nicht leicht möglich, daraus die IP-Adresse zu gewinnen. Diese Daten werden automatisch gelöscht, sobald sie nicht mehr benötigt werden. Ich werde diese Daten nicht ohne vorliegenden Gerichtsbeschluss herausgeben. Es ist <em>der Zweck</em> eines anonymisierten Meldeverfahrens, dass der meldende Mensch anonym bleibt.</p>

      <h2>Machen sie mit! <a name="dabei" href="#nav" title="Zurück">⇧</a></h2>
      <p>Die für diese Website verwendete Software ist <em>Frei</em> im Sinne von Freiheit (und nicht nur im Sinne von »Freibier«), unter einer <a href="http://www.tamagothi.de/impressum/lizenz/">sehr liberalen Lizenz</a> lizenziert, kann heruntergeladen, nach Herzenslust weitergegeben und verbreitet und sehr leicht an beliebige andere Orte anpasst werden. Es wird lediglich ein preiswertes Webhosting mit PHP benötigt, um eine derartige Website für einen anderen Ort zum Laufen zu bringen. Eine Datenbank ist nicht erforderlich. Es kommt nicht zu einer großen Serverlast, und es wird nur sehr wenig Speicher benötigt. Auch sehr preiswerte Hoster können genutzt werden. Benutzen sie einfach die Web-Suchmaschine ihres Vertrauens <a href="https://duckduckgo.com/?q=Webhosting">und sehen sie selbst, wie wenig Kosten das verursacht</a>.</p>
      <p>Es gibt viele Orte in Deutschland, in denen es leider nötig ist, die Behörden zu unterstützen, weil der Missbrauch von Mietwohnungen den Wohnungsmangel und die damit verbundenen, für viele Menschen existenziellen Probleme verschärft.</p>
      <p><a href="<?php echo DOWNLOAD_LINK; ?>">Freier Download</a></p>
      
      <h2>Impressum <a name="impressum" href="#nav" title="Zurück">⇧</a></h2>
      <p>Für diese Website ist <a href="<?php echo LINK_IMPRESSUM; ?>"><?php echo NAME_IMPRESSUM; ?></a> inhaltlich verantwortlich. Sie wird <em>nicht</em> von den und auch nicht auf Anregung der Behörden <?php echo ORT_MELDUNG; ?> betrieben.</p>
    </div>
  </body>
</html>
<!-- CODE IS PROSA, NOT POETRY! -->